'-----------------------------------------------------------------------
'               Copyright (C) 1993 Voice Data Management, Inc.
'
' You have a royalty-free right to use, modify, reproduce and distribute
' the Sample Application Files (and/or any modified version) in any way
' you find useful, provided that you agree that Voice Data Management, Inc.
' and Microsoft Corporation have no warranty, obligations or liability
' for any Sample Application Files.
' -----------------------------------------------------------------------
Option Explicit

'===============================================================
' This string needs to be set to the message class of the Form
' as declared in msmail.ini or shared.ini.
'===============================================================
Global Const MESSAGE_CLASS = "IPM.MSWGTemplates.RQuery"
'===============================================================
' This string is prepended to the textized version of the form
' that is placed in the Note Text field of a Mapi Message.
' The Note Text field is what users who don't have the form required
' to correctly view the message will see instead.
'===============================================================
Global Const FORM_REQUIRED_COMMENT = "Displaying this message correctly requires a custom E-Form that is not available or is incorrectly installed.  Please contact your network administrator for more information."
'===============================================================
' This string is prepended to the subject line given to mail.  The
' subject line in mail will consist of this string followed by
' the contents of the subject edit control
'===============================================================
Global Const SUBJECT_PREFIX = "Generic: "


'Mail Form errors
Global Const E_BAD_COMMAND_LINE = 21000
Global Const E_PACKAGE_NOT_FOUND = 21001

'Remote Query Declarations
Global Const SEND_AGAIN_STRING = "Re-&Send"
Global Const WN_SUCCESS = &H0
Global Const WN_NOT_CONNECTED = &H30
Declare Function GetPrivateProfileString Lib "Kernel" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Integer, ByVal lpFileName As String) As Integer
Declare Function WritePrivateProfileString Lib "Kernel" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal lpString As String, ByVal lplFileName As String) As Integer
Declare Function WNetGetConnection Lib "User" (ByVal lpszLocalName As String, ByVal lpszRemoteName As String, cbRemoteName As Integer) As Integer
Declare Function WNetAddConnection Lib "User" (ByVal lpszNetPath As String, ByVal lpszPassword As String, ByVal lpszLocalName As String) As Integer
Declare Function WNetCancelConnection Lib "User" (ByVal lpszName As String, ByVal bForce As Integer) As Integer

Declare Function GetWindowWord Lib "User" (ByVal hWnd As Integer, ByVal nIndex As Integer) As Integer
Global Const GWW_HWNDPARENT = (-8)
Declare Function ShowWindow Lib "User" (ByVal hWnd As Integer, ByVal nCmdShow As Integer) As Integer

' ShowWindow() Commands
Global Const SW_HIDE = 0
Global Const SW_SHOWNORMAL = 1
Global Const SW_NORMAL = 1
Global Const SW_SHOWMINIMIZED = 2
Global Const SW_SHOWMAXIMIZED = 3
Global Const SW_MAXIMIZE = 3
Global Const SW_SHOWNOACTIVATE = 4
Global Const SW_SHOW = 5
Global Const SW_MINIMIZE = 6
Global Const SW_SHOWMINNOACTIVE = 7
Global Const SW_SHOWNA = 8
Global Const SW_RESTORE = 9

Declare Function ShellExecute Lib "Shell" (ByVal hWnd As Integer, ByVal lpszOp As String, ByVal lpszFile As String, ByVal lpszparams As String, ByVal lpszDir As String, ByVal fsShowCommand As Integer) As Integer

Sub DoFormLoad (frm As Form)

    On Error GoTo HandleErrorFL

    InitializeCanvas frm
    ' Center the form on the screen
    frm.Left = (Screen.Width - frm.Width) / 2
    frm.Top = (Screen.Height - frm.Height) / 2

    gDefaultCaption = frm.Caption
    ' Set the gForm variable so the MEFLink Form knows which form is loaded.
    Set gForm = frm
    If gMessageID = "" Then
	frm!mnuDelete.Enabled = False
    End If
    If gCommand <> wcommandCompose Then ReadMessage frm

    ' For the cases below, we will unload the form
    ' as soon as we are done loading it, we just use
    ' the form for easy data access...
    Select Case gCommand
	Case wcommandReply, wcommandReplyToAll
	    DoReplyCmd frm, gCommand
	Case wcommandPrint
	    DoPrint frm
	Case wcommandSave
	    DoSaveAs frm
	Case wcommandForward
	    ' For this case we just leave up the compose form,
	    ' but erase the date so we get a new one
	    gMessage.DateReceived = ""
    End Select

    Exit Sub

HandleErrorFL:
    ReportError
    Exit Sub

End Sub

Sub DoFormQueryUnload (frm As Form, cancel As Integer)

    Dim errorCode As Long
    Dim message As String
    Dim cmd As Integer

    On Error GoTo HandleErrorFQU

    cancel = False

    If gModified Then

	message = "Do you want to save changes to '" & frm.Caption & "'"
	If gMessageID = "" Then message = message & " in the Inbox"
	message = message & "?"

	Select Case MsgBox(message, MB_YESNOCANCEL + MB_ICONQUESTION, App.Title)
	    Case IDCANCEL
		cancel = True
		Exit Sub
	    Case IDYES
		Screen.MousePointer = HOURGLASS
		If frm Is frmRead Then
		    cmd = wcommandOpen
		Else
		    ' Reset the date string to "" so we get the current date/time
		    gMessage.DateReceived = ""
		    cmd = wcommandCompose
		End If
		WriteMessage frm, cmd
		If gMessageID = "" Then
		    gMessageID = String$(64, 0)
		Else
		    ' MAPI treats "" as 'leave the subject alone', so
		    ' use " " to show we really want to reset it.
		    If gMessage.Subject = "" Then gMessage.Subject = " "
		End If
		gInMapi = True
		errorCode = MAPISaveMail(gSession, 0, gMessage, gRecipients(0), gFiles(0), 0, 0, gMessageID)
		gInMapi = False
		If (errorCode <> 0) And (InStr(gMessageID, Chr$(0)) <> 1) Then
		    ' message has been deleted while we were running, try saving to new ID.
		    gMessageID = String$(64, 0)
		    gInMapi = True
		    errorCode = MAPISaveMail(gSession, 0, gMessage, gRecipients(0), gFiles(0), 0, 0, gMessageID)
		End If
		MEFCheckMapiError errorCode
	End Select
    End If

    Screen.MousePointer = Default
    Exit Sub

HandleErrorFQU:
    Screen.MousePointer = Default
    cancel = True
    ReportError
    Exit Sub

End Sub

Sub DoPrint (frm As Form)
    
    On Error GoTo HandleErrorDP
    Dim labelWidth As Single

    MEFBeginPrinting "'" & frm.Caption & "'"

    MEFPrintRecipient gUser.Name
    labelWidth = printer.TextWidth("Subject:000000")
    'If frm Is frmRead Then MEFPrintLabelAndValue "From:", frm!txtOriginator, labelWidth, gPrintWidth
    'If frm!lstToRecipients.ListCount > 0 Then MEFPrintLabelAndValue "To:", TextizeListBox(frm!lstToRecipients, "; "), labelWidth, gPrintWidth
    'If frm!lstCCRecipients.ListCount > 0 Then MEFPrintLabelAndValue "CC:", TextizeListBox(frm!lstCCRecipients, "; "), labelWidth, gPrintWidth
    'If frm!txtSubject <> "" Then MEFPrintLabelAndValue "Subject:", frm!txtSubject, labelWidth, gPrintWidth
    If frm Is frmRead Then MEFPrintLabelAndValue "Date:", frm!txtDateReceived, labelWidth, gPrintWidth
    MEFPrintBlankLines 2
    'MEFPrintMultiLineText frm!txtNote, gPrintWidth
    '================================================
    ' Add your printing code here
    '================================================
    MEFEndPrinting
    Exit Sub

HandleErrorDP:
    If Not MEFHandlePrintingError() Then ReportError
    Exit Sub
End Sub

Sub DoReplyCmd (frm As Form, ByVal cmd As Integer)
    ' Textize the current message, and use this
    ' as the initial data based to MAPISendMail
    Dim body As String
    Dim header As String
    Dim ret As Integer

    On Error GoTo HandleErrorDR

    ' SetupReply will set up the recipients for the call,
    ' set up the subject of the message, and return
    ' a textized version of the header.
    header = SetupReply(cmd, gMessage, gOriginator, gRecipients(), gUser)
    ' Now append a textized version of the form data.
    ' TextizeForm is in Eform.Bas as it changes with the form.
    body = Chr$(13) & Chr$(10) & "----------" & Chr$(13) & Chr$(10) & header & Chr$(13) & Chr$(10) & TextizeForm(frm)
    gMessage.NoteText = body
    ' Message type is generic note
    gMessage.MessageType = "IPM.Microsoft Mail.Note"

    ' Strip off the package attachments.
    ' This may need to be more complex if form includes user file attachments
    MEFFreeAttachments
    gMessage.FileCount = 0
    
    ' Call mapi to display initialized SendNote form.
    gInMapi = True
    ret = MAPISendMail(gSession, 0, gMessage, gRecipients(0), gFiles(0), MAPI_DIALOG, 0)
    gInMapi = False
    If ret <> MAPI_USER_ABORT Then
	MEFCheckMapiError ret
    End If
    Exit Sub
    
HandleErrorDR:
    ReportError
    Exit Sub
    
End Sub

Sub DoReplyForward (frm As Form, ByVal cmd As Integer)

    Dim Filename As String
    Dim s As String

    On Error GoTo HandleErrorRF

    Screen.MousePointer = HOURGLASS
    Filename = MEFGetTempFile()
    WriteMessage frm, cmd
    MEFCheckMEFError MEFWriteMessageToFile(gMessage, gOriginator, gRecipients(0), gFiles(0), Filename, 0)
    s = "<MC:" & MESSAGE_CLASS & ">" & App.Path & "\" & App.EXEName & ".EXE /FILE " & Format$(cmd) & " " & Filename
    MEFCheckMEFError MEFExecEform(frm.hWnd, s)
    Screen.MousePointer = Default
    ' If we haven't modified the old form close it down.
    If gModified = False Then
	Unload frm
    End If
    Exit Sub

HandleErrorRF:
    Screen.MousePointer = Default
    ReportError
    Exit Sub

End Sub

Sub DoSaveAs (frm As Form)

    Dim Filename As String
    Dim fileNum As Variant

    On Error GoTo HandleErrorDSA

    frm!dlgSaveAs.Action = 2 'DLG_SAVE
    Filename = frm!dlgSaveAs.Filename
    If Filename = "" Then Exit Sub

    fileNum = FreeFile
    Open Filename For Output As #fileNum

    'If frm Is frmRead Then Print #fileNum, "From: " & frm!txtOriginator
    'If frm!lstToRecipients.ListCount > 0 Then Print #fileNum, "To: " & TextizeListBox(frm!lstToRecipients, "; ")
    'If frm!lstCCRecipients.ListCount > 0 Then Print #fileNum, "CC: " & TextizeListBox(frm!lstCCRecipients, "; ")
    If frm Is frmRead Then Print #fileNum, "Date: " & frm!txtDateReceived
    'If frm!txtSubject <> "" Then Print #fileNum, "Subject: " & frm!txtSubject
    'If frm!txtNote <> "" Then
    '    Print #fileNum, ""
    '    Print #fileNum, frm!txtNote
    'End If
    '================================================
    ' Add your saving code here
    '================================================

    Close #fileNum

    Exit Sub

HandleErrorDSA:
    ReportError
    Exit Sub

End Sub

Function GetINIString (AppName, KeyName, INIFileName) As String
    ' GetINIString returns a string from an .INI file.
    ' The function looks first for a local .INI in
    ' the default INI directory determined by Windows.
    ' The function looks next for a shared .INI in the
    ' SharedExtensionsDir of MSMAIL.INI.
    
    Dim ReturnedString As String
    Dim i As Integer, Size As Integer, Result As Integer
    Dim SharedExtensionsDir As String
    Dim SharedExtensionsServer As String

    'Try local .INI File
    ReturnedString = Space$(256)
    Size = Len(ReturnedString)
    Size = GetPrivateProfileString(AppName, KeyName, "", ReturnedString, Size, INIFileName)
    ReturnedString = Left$(ReturnedString, Size)
    If ReturnedString <> "" Then
	'Success
	GetINIString = ReturnedString
	Exit Function
    End If
    
    'Not found in local .INI file, so try SharedExtensionsDir
    ReturnedString = Space$(256)
    Size = Len(ReturnedString)
    Size = GetPrivateProfileString("Microsoft Mail", "SharedExtensionsDir", "", ReturnedString, Size, "MSMAIL.INI")
    SharedExtensionsDir = Left$(ReturnedString, Size)
    If SharedExtensionsDir = "" Then
	'Failure: No SharedExtensionsDir is listed
	GetINIString = ""
	Exit Function
    End If
    
    'If SharedExtensionsDir is a UNC (network) name, make a temporary connection
    'with an available drive letter
    If Left$(SharedExtensionsDir, 2) = "\\" Then
	'Extract the \\Server\Share name
	Dim FourthSlash As Integer
	FourthSlash = InStr(InStr(3, SharedExtensionsDir, "\") + 1, SharedExtensionsDir, "\")
	If FourthSlash = 0 Then
	    SharedExtensionsServer = SharedExtensionsDir
	    SharedExtensionsDir = "\"
	Else
	    SharedExtensionsServer = Left$(SharedExtensionsDir, FourthSlash - 1)
	    SharedExtensionsDir = Mid$(SharedExtensionsDir, FourthSlash)
	End If
	
	Dim Drive As String
	For i = Asc("Z") To Asc("D") Step -1
	    Drive = Chr$(i) + ":"
	    ReturnedString = Space$(256)
	    Result = WNetGetConnection(Drive, ReturnedString, 256)
	    If Result = WN_NOT_CONNECTED Then
		'This drive is available
		Result = WNetAddConnection(ByVal SharedExtensionsServer, "", Drive)
		If Result <> WN_SUCCESS Then
		    'Failure: Could not connect to SharedExtensionsDir
		    GetINIString = ""
		    Exit Function
		End If
		SharedExtensionsDir = Drive & SharedExtensionsDir
		Exit For
	    Else
		Drive = ""
	    End If
	Next
    End If
    
    'If SharedExtensionsDir does not end with "\", then append a "\"
    If Right$(SharedExtensionsDir, 1) <> "\" Then SharedExtensionsDir = SharedExtensionsDir & "\"
    INIFileName = SharedExtensionsDir + INIFileName
    ReturnedString = Space$(256)
    Size = Len(ReturnedString)
    Size = GetPrivateProfileString(AppName, KeyName, "", ReturnedString, Size, INIFileName)
    ReturnedString = Left$(ReturnedString, Size)
    If ReturnedString <> "" Then
	'Success
	GetINIString = ReturnedString
    Else
	'Failure: Setting not available in shared INI file
	GetINIString = ""
    End If
	
    'Break the temporary net connection
    Result = WNetCancelConnection(Drive, True)

End Function

Sub Main ()

    Dim commandLine As String
    Dim token As String
    Dim i As Integer

    On Error GoTo HandleErrorM
    ' Do one time initialization of globals.
    gSession = 0
    gAppTitle = App.Title
    ' The first thing we must do is Load the hidden control form.
    Load frmMEFlink
    ' Now we have a control to handle the connection to the MEF Cache
    
    'Parse the command line.
    commandLine = Command$
    ParseCommandLine commandLine
    Exit Sub

HandleErrorM:
    ReportError
    QueryTerminate
    Exit Sub
End Sub

Sub ParseCommandLine (commandLine As String)
    Dim token As String
    Dim i As Integer

    ' Do per command initialization
    Screen.MousePointer = HOURGLASS
    ReInitialize
    ' reset app title to put us back in the task manager
    App.Title = gAppTitle
    ' Now show the 0 size VB window that is the parent of everything
    ' in our app to get us in the TAB sequence
    Dim hwndFrm As Integer
    Dim hwndParent As Integer
    Dim junk As Integer
    hwndFrm = frmMEFlink.hWnd
    ' Can't use GetParent for this.  It returns NULL
    hwndParent = GetWindowWord(hwndFrm, GWW_HWNDPARENT)
    ' It's not a VB window, so can't just set it's visible property to true.
    junk = ShowWindow(hwndParent, SW_SHOW)

    token = MEFGetToken(commandLine, " ")

    If token = "" Then

	'Compose new message when started with no command line arguments.
	gCommand = wcommandCompose
	MEFCheckMEFError MEFCreatePackage(gPackage, 0)

    ElseIf token Like "[-/]MSG" Then

	'Read data from the message store.
	gCommand = Val(MEFGetToken(commandLine, " "))
	gMessageID = MEFGetToken(commandLine, " ")

	If gCommand = wcommandCompose Then
	    MEFCheckMEFError MEFCreatePackage(gPackage, 0)
	    ' Ensure we don't overwrite some other message later
	    gMessageID = ""
	Else
	    gInMapi = True
	    MEFCheckMapiError MAPIReadMail(gSession, 0, gMessageID, 0, 0, gMessage, gOriginator, gRecipients(), gFiles())
	    i = MEFFindAttachment(PACKAGE_FILE_NAME)
	    If i < 0 Then Error E_PACKAGE_NOT_FOUND
	    MEFCheckMEFError MEFOpenPackage(gFiles(i).PathName, gPackage, 0)
	    ' Ensure we don't delete the message later
	    If gCommand = wcommandForward Then gMessageID = ""
	End If

    ElseIf token Like "[-/]FILE" Then

	' Read data from a file. This is usually a file
	' created by a previous instance of the form when
	' a new instance is being launched for Reply or Forward.
	gCommand = Val(MEFGetToken(commandLine, " "))
	token = MEFGetToken(commandLine, " ")
	MEFCheckMEFError MEFReadMessageFromFile(gMessage, gOriginator, gRecipients(), gFiles(), token, 0)
	i = MEFFindAttachment(PACKAGE_FILE_NAME)
	If i < 0 Then Error E_PACKAGE_NOT_FOUND
	MEFCheckMEFError MEFOpenPackage(gFiles(i).PathName, gPackage, 0)
	Kill token

    Else
	Error E_BAD_COMMAND_LINE
    End If

    ' Let MEF know we are up and running
    MEFCheckMEFError MEFRegisterInstance(frmMEFlink.MEFLink1.hWnd, MESSAGE_CLASS, gMessageID)
    
    'Load form based on command and message flags.
    
    Select Case gCommand
	Case wcommandCompose
	    frmCompose.Show
	Case wcommandOpen
	    If gMessage.Flags And MAPI_SENT Then
		If gOriginator.Address <> gUser.Address Then
		    frmRead.Show
		Else
		    frmCompose.Show
		    frmCompose!cmdSend.Caption = SEND_AGAIN_STRING
		End If
	    Else
		frmCompose.Show
	    End If
	Case wcommandForward
	    ' Textize the header, ReadMessage will
	    ' prepend this string to the text in the edit
	    gForwardHeader = SetupForward(gCommand, gMessage, gOriginator, gRecipients(), gUser)
	    frmCompose.Show
	Case wcommandReply, wcommandReplyToAll
	    ' Load data into form without displaying,
	    ' Calls DoReplyCmd in DoFormLoad
	    Load frmRead
	    ' Unload will generate a runtime error
	    ' If done in load proc, so do it here
	    Unload frmRead

	Case wcommandPrint, wcommandSave
	    ' Load data into form without displaying,
	    ' Calls DoPrint or DoSaveAs in DoFormLoad
	    If gMessage.Flags And MAPI_SENT Then
		Load frmRead
		Unload frmRead
	    Else
		Load frmCompose
		Unload frmCompose
	    End If
	Case Else
	    Error E_BAD_COMMAND_LINE
    End Select
    Screen.MousePointer = 0
    Exit Sub

End Sub

Sub QueryTerminate ()
    
    'Clean up and check with MEF for if we should exit or sleep
    Dim wRet As Integer

    If gPackage <> 0 Then
	MEFCheckMEFError MEFFreePackage(gPackage)
	gPackage = 0
    End If

    MEFFreeAttachments

    ' Call MEF to find out if we should exit or sleep
    wRet = MEFQueryExit(frmMEFlink.MEFLink1.hWnd)
    If wRet = MEF_EXIT Then
	Terminate
    Else
	' Go to Sleep. We should currently have no forms
	' visible as we are called only from error exits
	' of loading, and from the FormUnload subroutine.
	' So we shouldn't have to unload anything at this point.
	' Setting our title to null removes us from the task list
	App.Title = ""
	' Now hide the 0 size VB window that is the parent of everything
	' in our app to get us out of the TAB sequence
	Dim hwndFrm As Integer
	Dim hwndParent As Integer
	Dim junk As Integer
	hwndFrm = frmMEFlink.hWnd
	' Can't use GetParent for this.
	hwndParent = GetWindowWord(hwndFrm, GWW_HWNDPARENT)
	' It's not a VB window, so can't just set it's visible property to false.
	junk = ShowWindow(hwndParent, SW_HIDE)
    End If

End Sub

Sub ReadMessage (frm As Form)
    
    Dim crlf As String
    Dim modified As Long

    ReadTaggedControls frm, gPackage
    
    ' Add code here to unpackage your data

    If gCommand = wcommandReply Or gCommand = wcommandReplyToAll Then
	' reset subject to strip out the SUBJECT_PREFIX.  We don't want
	' the prefix for reply as reply uses the normal mail note.
	'gMessage.Subject = frm!txtSubject
    End If

    'If frm!txtSubject <> "" Then frm.Caption = frm!txtSubject
    
    If frm Is frmRead Then
	'frm!txtOriginator = gOriginator.Name
	' Check and see if the form has been saved since it was received
	modified = MEFReadLong(gPackage, "modified", 0)
	If modified <> 0 Then
	    'frm!lblFrom = "*&From:"
	End If
	frm!txtDateReceived = MEFFormatMAPIDate(gMessage.DateReceived)
    End If

    If gForwardHeader <> "" Then
	crlf = Chr$(13) & Chr$(10)
	'frm!txtNote = crlf & "----------" & crlf & gForwardHeader & crlf & frm!txtNote
    End If

    'MEFAddRecipientsToListBox gRecipients(), gMessage.RecipCount, MAPI_TO, frm!lstToRecipients
    'MEFAddRecipientsToListBox gRecipients(), gMessage.RecipCount, MAPI_CC, frm!lstCCRecipients
    
    gModified = False

End Sub

Sub ReadTaggedControls (frm As Form, ByVal package As Long)
    
    Dim i As Integer
    Dim Tag As String
    Dim ctrl As Control
    Dim Index As Long

    For i = 0 To frm.Controls.Count - 1
	Set ctrl = frm.Controls(i)
	If ctrl.Tag <> "" Then
	    Tag = ctrl.Tag

	    'Native controls.

	    If TypeOf ctrl Is CheckBox Then
		ctrl.Value = MEFReadLong(package, Tag, 0)
	    ElseIf TypeOf ctrl Is ComboBox Then
		' The combo is a special case as the text might not have
		' been in the list.  In this case we stored the text too.
		Index = MEFReadLong(package, Tag, 0)
		If Index <> -1 Then
		    ctrl.ListIndex = Index
		ElseIf ctrl.Style <> 2 Then   ' User typed in text
		    ctrl.Text = MEFReadText(package, Tag + "_Text", "")
		End If
	    ElseIf TypeOf ctrl Is HScrollBar Then
		ctrl.Value = MEFReadLong(package, Tag, 0)
	    ElseIf TypeOf ctrl Is ListBox Then
		ctrl.ListIndex = MEFReadLong(package, Tag, 0)
	    ElseIf TypeOf ctrl Is OptionButton Then
		ctrl.Value = MEFReadLong(package, Tag, 0)
	    ElseIf TypeOf ctrl Is TextBox Then
		ctrl.Text = MEFReadText(package, Tag, "")
	    ElseIf TypeOf ctrl Is VScrollBar Then
		ctrl.Value = MEFReadLong(package, Tag, 0)
	    
	    'Controls in THREED.VBX.

	    ElseIf TypeOf ctrl Is SSCheck Then
		ctrl.Value = MEFReadLong(package, Tag, 0)
	    ElseIf TypeOf ctrl Is SSOption Then
		ctrl.Value = MEFReadLong(package, Tag, 0)
	    ElseIf TypeOf ctrl Is SSRibbon Then
		ctrl.Value = MEFReadLong(package, Tag, 0)

	    'Grid Control

	    ElseIf TypeOf ctrl Is Grid Then
		Dim gridClip As String
		gridClip = MEFReadText(package, Tag, "")
		ctrl.Rows = Val(MEFGetToken(gridClip, Chr$(9)))
		ctrl.Cols = Val(MEFGetToken(gridClip, Chr$(9)))
		ctrl.SelStartRow = ctrl.FixedRows
		ctrl.SelEndRow = ctrl.Rows - 1
		ctrl.SelStartCol = ctrl.FixedCols
		ctrl.SelEndCol = ctrl.Cols - 1
		ctrl.Clip = gridClip
		ctrl.SelEndRow = ctrl.SelStartRow
		ctrl.SelEndCol = ctrl.SelStartCol
		gridClip = ""

	    'Add other custom controls here.
	    ElseIf TypeOf ctrl Is MaskEdBox Then
		ctrl.Text = MEFReadText(package, Tag, "")
	    End If

	End If
    Next
 
End Sub

Sub ReInitialize ()
    'Initialize global variables

    gMessageID = ""
    gForwardHeader = ""
    gCommand = 0
    gPackage = 0
    gInMapi = False
    gModified = False
    ' Initialize Message variables
    gMessage.RecipCount = 0
    gMessage.FileCount = 0
    ReDim gFiles(0) As MapiFile
    ReDim gRecipients(0) As MapiRecip
    ' We don't set these strings on save or send, so ensure they get
    ' reset here in case we have leftover data from a previous message
    gMessage.DateReceived = ""
    gMessage.ConversationID = ""

    'If needed, Logon to the mail system
    If gSession = 0 Then
	gInMapi = True
	MEFCheckMapiError MAPILogon(0, "", "", MAPI_LOGON_UI, 0, gSession)
	MEFCheckMEFError MEFWhoAmI(gSession, gUser)
    End If

End Sub

Sub ReportError ()

    Dim errorText As String
    Dim errorIcon As Integer

    ' Default icon is the '!'.  This can be
    ' overridden for special cases below
    errorIcon = MB_ICONEXCLAMATION

    Select Case Err

	'Add cases for your errors here.

	Case E_BAD_COMMAND_LINE
	    errorText = "Bad command line."
	Case E_PACKAGE_NOT_FOUND
	    errorText = "This message is missing some information and can not be displayed.  Please ask the sender to resend it."
	Case E_FIRST_MEF To E_LAST_MEF
	    errorText = GetMEFErrorText(Err - E_FIRST_MEF)
	Case E_FIRST_MAPI To E_LAST_MAPI
	    errorText = GetMAPIErrorText(Err - E_FIRST_MAPI)
	Case 482
	    errorText = "Printer Error: There is some problem that prevents printing.  "
	    errorText = errorText & "Some possible causes are:  "
	    errorText = errorText & "You don't have a printer selected from the Windows Control Panel, "
	    errorText = errorText & "your printer is not online, "
	    errorText = errorText & "or your printer is jammed or out of paper."
	Case Else
	    errorText = Error$
    End Select

    If errorText <> "" Then MsgBox errorText, errorIcon, App.Title

End Sub

Sub Terminate ()
    ' Exit the E-Form instance.
    If gSession <> 0 Then
	gInMapi = True
	MEFCheckMapiError MAPILogoff(gSession, 0, 0, 0)
	gInMapi = False
	gSession = 0
    End If
    ' An app with no visible forms won't exit if another app
    ' is holding the vb runtime in memory.  So we show the
    ' MEFLink form (our only loaded form at this point) offscreen first.
    frmMEFlink.Top = Screen.Height
    frmMEFlink.Left = Screen.Width
    frmMEFlink.Show
    End
End Sub

Function TextizeForm (frm As Form) As String
    Dim textize As String
    ' Textize the values on the given form.
    ' For the Generic form this just consists
    ' of the edit control.
    'textize = frm.txtNote.Text
    '================================================
    ' Add your textizing code here
    '================================================
    TextizeForm = textize
End Function

Sub WriteMessage (frm As Form, cmd As Integer)
    ' frm is the Form with the data we are writing.
    ' cmd is what we are writing the message for:
    '   wcommandSend if we are sending
    '   wcommandCompose if we are saving to the store from the compose form
    '   wcommandOpen if we are saving to the store from the read form
    '   wcommandReply, wcommandReplyAll, or wcommandForward if we are saving
    '       to a file to launch a new instance to handle these commands.

    Dim i As Integer

    'Write form data to message and package.

    gMessage.MessageType = MESSAGE_CLASS
    gMessage.Subject = frmCompose.Caption
    WriteTaggedControls frm, gPackage
    
    ' Add code here to package your data

    ' If this is the read form, set the modified flag so we know it's been touched
    ' we test cmd because we don't want to do this for Forward or Reply, which are
    ' also done from the read form.
    If cmd = wcommandOpen Then
	Dim modified As Long
	modified = 1
	MEFCheckMEFError MEFWriteItem(gPackage, "modified", MEF_LONG, modified, 4, 0)
    End If
    
    'If package not attached to message, then do it now.
    'Save package to disk.

    i = MEFFindAttachment(PACKAGE_FILE_NAME)
    If i < 0 Then i = MEFAddAttachment(MEFGetTempFile(), PACKAGE_FILE_NAME)
    MEFCheckMEFError MEFSavePackage(gPackage, gFiles(i).PathName, 0)
    
    gMessage.NoteText = TextizeForm(frm) & Chr$(13) & Chr$(10) & String$(gMessage.FileCount, " ")
    
    If cmd = wcommandSend Or cmd = wcommandCompose Then
	' Add explanatory comment for users without the form.
	If FORM_REQUIRED_COMMENT <> "" Then
	    Dim seperator As String
	    seperator = "============================================================" & Chr$(13) & Chr$(10)
	    gMessage.NoteText = seperator & FORM_REQUIRED_COMMENT & Chr$(13) & Chr$(10) & seperator & gMessage.NoteText
	End If
    End If
    
    'Add extra characters to note text for attachments.
    'Reposition the attachments to this area.

    For i = 0 To gMessage.FileCount - 1
	gFiles(i).Position = Len(gMessage.NoteText) - i - 1
    Next

End Sub

Sub WriteTaggedControls (frm As Form, ByVal package As Long)
    
    Dim i As Integer
    Dim Tag As String
    Dim ctrl As Control
    Dim errorCode As Integer

    For i = 0 To frm.Controls.Count - 1
	Set ctrl = frm.Controls(i)
	If ctrl.Tag <> "" Then
	    Tag = ctrl.Tag

	    'Native controls.

	    If TypeOf ctrl Is CheckBox Then
		MEFWriteLong package, Tag, CLng(ctrl.Value)
	    ElseIf TypeOf ctrl Is ComboBox Then
		' Write both the list index and the text, since text may not be in list
		MEFWriteLong package, Tag, CLng(ctrl.ListIndex)
		If ctrl.ListIndex = -1 And ctrl.Style <> 2 Then
		    MEFWriteText package, Tag + "_Text", CStr(ctrl.Text)
		End If
	    ElseIf TypeOf ctrl Is HScrollBar Then
		MEFWriteLong package, Tag, CLng(ctrl.Value)
	    ElseIf TypeOf ctrl Is ListBox Then
		MEFWriteLong package, Tag, CLng(ctrl.ListIndex)
	    ElseIf TypeOf ctrl Is OptionButton Then
		If ctrl.Value Then
		    MEFWriteLong package, Tag, CLng(ctrl.Value)
		Else
		    errorCode = MEFDeleteItem(package, Tag, 0)
		    If errorCode <> MEF_NO_DATA Then MEFCheckMEFError errorCode
		End If
	    ElseIf TypeOf ctrl Is TextBox Then
		MEFWriteText package, Tag, CStr(ctrl.Text)
	    ElseIf TypeOf ctrl Is VScrollBar Then
		MEFWriteLong package, Tag, CLng(ctrl.Value)

	    'Controls in THREED.VBX

	    ElseIf TypeOf ctrl Is SSCheck Then
	       MEFWriteLong package, Tag, CLng(ctrl.Value)
	    ElseIf TypeOf ctrl Is SSOption Then
		If ctrl.Value Then
		    MEFWriteLong package, Tag, CLng(ctrl.Value)
		Else
		    errorCode = MEFDeleteItem(package, Tag, 0)
		    If errorCode <> MEF_NO_DATA Then MEFCheckMEFError errorCode
		End If
	    ElseIf TypeOf ctrl Is SSRibbon Then
		If ctrl.Value Then
		    MEFWriteLong package, Tag, CLng(ctrl.Value)
		Else
		    errorCode = MEFDeleteItem(package, Tag, 0)
		    If errorCode <> MEF_NO_DATA Then MEFCheckMEFError errorCode
		End If

	    'Grid Control

	    ElseIf TypeOf ctrl Is Grid Then
		Dim gridClip As String
		Dim SelStartRow As Integer, SelEndRow As Integer
		Dim SelStartCol As Integer, SelEndCol As Integer
		SelStartRow = ctrl.SelStartRow
		SelEndRow = ctrl.SelEndRow
		SelStartCol = ctrl.SelStartCol
		SelEndCol = ctrl.SelEndCol
		ctrl.SelStartRow = ctrl.FixedRows
		ctrl.SelEndRow = ctrl.Rows - 1
		ctrl.SelStartCol = ctrl.FixedCols
		ctrl.SelEndCol = ctrl.Cols - 1
		gridClip = Format$(ctrl.Rows) & Chr$(9) & Format$(ctrl.Cols) & Chr$(9) & ctrl.Clip
		MEFWriteText package, Tag, gridClip
		gridClip = ""
		ctrl.SelStartRow = SelStartRow
		ctrl.SelEndRow = SelEndRow
		ctrl.SelStartCol = SelStartCol
		ctrl.SelEndCol = SelEndCol

	    'Add other custom controls here.

	    ElseIf TypeOf ctrl Is MaskEdBox Then
		MEFWriteText package, Tag, CStr(ctrl.Text)
	    End If

	End If
    Next
End Sub

